unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ToolWin, Menus;

type
  TfmMain = class(TForm)
    mnuMain: TMainMenu;
    mnuFile: TMenuItem;
    mnuFileExit: TMenuItem;
    View1: TMenuItem;
    mnuViewToolbar: TMenuItem;
    mnuViewStatusBar: TMenuItem;
    mnuHelp: TMenuItem;
    mnuHelpAbout: TMenuItem;
    mnuHelpHowtoUseHelp: TMenuItem;
    mnuHelpSearchforHelpOn: TMenuItem;
    mnuHelpContents: TMenuItem;
    StatusBar: TStatusBar;
    ToolBar: TToolBar;
    ToolButton1: TToolButton;
    ilToolbar: TImageList;
    tvMixers: TTreeView;
    procedure mnuFileExitClick(Sender: TObject);
    procedure mnuViewToolbarClick(Sender: TObject);
    procedure mnuViewStatusBarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmMain: TfmMain;

implementation

{$R *.DFM}

uses mmsystem;

procedure TfmMain.mnuFileExitClick(Sender: TObject);
begin
  Close
end;

procedure TfmMain.mnuViewToolbarClick(Sender: TObject);
begin
  Toolbar.Visible := not Toolbar.Visible
end;

procedure TfmMain.mnuViewStatusBarClick(Sender: TObject);
begin
  StatusBar.Visible := not StatusBar.Visible
end;

procedure TfmMain.FormShow(Sender: TObject);
var
  i, j, k, l, numDevs : Integer;
  caps : TMixerCaps;
  sourceLineNode, node, lineNode, sourceNode : TTreeNode;
  handle : HMIXER;
  lineInfo, connectionInfo : TMixerLine;
  mixerLineControls : TMixerLineControls;
  p, controls : PMixerControl;
begin
  Caption := Application.Title;
  with tvMixers do  // Turn off tooltips
    SetWindowLong (handle, GWL_STYLE, GetWindowLong (handle, GWL_STYLE) or $80);

  numDevs := MixerGetNumDevs;

  for i := 0 to numDevs - 1 do
  begin
    MixerGetDevCaps (i, @caps, sizeof (caps));
    node := tvMixers.Items.Add (Nil, caps.szPName);
    if mixerOpen (@handle, i, 0, 0, MIXER_OBJECTF_MIXER) = MMSYSERR_NOERROR then
    try
      for j := 0 to caps.cDestinations - 1 do
      begin
        lineInfo.cbStruct := sizeof (lineInfo);
        lineInfo.dwDestination := j;
        if mixerGetLineInfo (handle, @lineInfo, MIXER_GETLINEINFOF_DESTINATION) = MMSYSERR_NOERROR then
        begin
          lineNode := tvMixers.Items.AddChild (node, lineInfo.szName);
          sourceNode := tvMixers.Items.AddChild (lineNode, 'Sources');
          for k := 0 to lineInfo.cConnections - 1 do
          begin
            connectionInfo.cbStruct := sizeof (connectionInfo);
            connectionInfo.dwDestination := j;
            connectionInfo.dwSource := k;
            mixerGetLineInfo (handle, @connectionInfo, MIXER_GETLINEINFOF_SOURCE);
            sourceLineNode := tvMixers.Items.AddChild (sourceNode, connectionInfo.szName);

            mixerLineControls.cbStruct := sizeof (mixerLineControls);
            mixerLineControls.dwLineID := connectionInfo.dwLineID;
            mixerLineControls.cControls := connectionInfo.cControls;
            mixerLineControls.cbmxctrl := sizeof (TMixerControl);
            GetMem (controls, sizeof (TMixerControl) * connectionInfo.cControls);
            mixerLineControls.pamxctrl := controls;
            try
              if mixerGetLineControls (handle, @mixerLineControls, MIXER_GETLINECONTROLSF_ALL) = MMSYSERR_NOERROR then
              begin
                p := controls;
                for l := 0 to mixerLineControls.cControls - 1 do
                begin
                  tvMixers.Items.AddChild (sourceLineNode, p^.szName);
                  Inc (p)
                end
              end
            finally
              FreeMem (controls)
            end
          end;

          mixerLineControls.cbStruct := sizeof (mixerLineControls);
          mixerLineControls.dwLineID := lineInfo.dwLineID;
          mixerLineControls.cControls := lineInfo.cControls;
          mixerLineControls.cbmxctrl := sizeof (TMixerControl);
          GetMem (controls, sizeof (TMixerControl) * lineInfo.cControls);
          mixerLineControls.pamxctrl := controls;
          try
            if mixerGetLineControls (handle, @mixerLineControls, MIXER_GETLINECONTROLSF_ALL) = MMSYSERR_NOERROR then
            begin
              p := controls;
              for k := 0 to mixerLineControls.cControls - 1 do
              begin
                tvMixers.Items.AddChild (lineNode, p^.szName);
                Inc (p)
              end
            end
          finally
            FreeMem (controls)
          end
        end
      end
    finally
      mixerClose (handle)
    end
  end
end;

end.
